#!/bin/bash


if [ $(id -u) != "0" ]; then
    echo -e "Please run this script with administrator privileges.\n"
    exit 1
fi



EMERGENCY=``
UPDATE=``
kernelheader=``
kernelsrc=``
if cat /etc/*release | grep ^NAME | grep Ubuntu || cat /etc/*release | grep ^NAME | grep Debian  || cat /etc/*release | grep ^NAME | grep Mint || cat /etc/*release | grep ^NAME | grep TmaxOS || cat /etc/*release | grep ^NAME | grep gooroom || cat /etc/*release | grep ^NAME | grep Mint ||  cat /etc/*release | grep ^NAME | grep Knoppix ; then
   UPDATE=apt-get 
   kernelheader=linux-headers-
   kernelsrc=linux-headers-	
   #$UPDATE install wget gcc make curl -y
elif cat /etc/*release | grep ^NAME | grep openSUSE ; then
   UPDATE=zypper 
   kernelheader=linux-headers-
   kernelsrc=linux-headers-	
   #$UPDATE install wget gcc make curl 

else
   UPDATE=yum
   kernelheader=kernel-devel-
   kernelsrc=kernels/
   #$UPDATE install wget gcc -y
fi



mkdir -p "/opt/turbovaccine/"


tar -zxvf ./turbovaccine.tar.gz -C /opt



echo -e "\n\033[1mTurboVaccine Antivirus for Linux 2.0\033[0m\n"
echo -e "\n\033[1mEnd User License Agreement\033[0m\n"
echo -e "\nPlease review the end user license agreement.\n"
echo -e "\nPress Enter to display it.\n"
read DISPLIC
cat /opt/turbovaccine/lib/EULA.txt | more

ACCEPT=NO
echo -n "Do you agree with this license?[Y/n]: "
while true; do
    read ANSWER
    if [ -z $ANSWER ]; then
        ACCEPT="YES"
        break;
    fi
    case $ANSWER in
    y|Y|yes|YES) 
        ACCEPT="YES"
        echo
        break
        ;;
    n|N|no|NO)
        ACCEPT="NO"
        echo
        break
        ;;
    *) 
        echo -n "Agree with this license?[Y/n]: "
        continue
        ;;
    esac
    break
done    

if [ "$ACCEPT" = "NO" ]; then
    exit 1
fi






echo ..
echo "Adding library and register turbovaccine"
cd /opt/turbovaccine/lib
#echo "cryptopp copy.."
#tar -zxvf ./libcryptopp.tar.gz -C /usr/lib
#echo "sqlite copy.."
#tar -zxvf ./libsqlite3.tar.gz -C /usr/lib

#echo "curl copy.."
#tar -zxvf ./libcurl.tar.gz -C /usr/lib



cp ./turbovaccine /etc/init.d/ 

#SYSEMD=/etc/systemd/system
#if [ -d "$SYSEMD" ] ; then
#cp ./turbovaccine2.service /etc/systemd/system/ 
#systemctl enable turbovaccine2.service
#fi

cd /etc/init.d/
chmod 755 turbovaccine

if cat /etc/*release | grep ^NAME | grep Ubuntu || cat /etc/*release | grep ^NAME | grep Debian  || cat /etc/*release | grep ^NAME | grep Mint  ||  cat /etc/*release | grep ^NAME | grep openSUSE || cat /etc/*release | grep ^NAME | grep TmaxOS || cat /etc/*release | grep ^NAME | grep gooroom ||  cat /etc/*release | grep ^NAME | grep Knoppix ; then
update-rc.d turbovaccine defaults
else
chkconfig --add turbovaccine
chkconfig --level 345 turbovaccine on 
fi

#/etc/init.d/turbovaccine start

echo -e "\n\033[1m백신 시리얼키를 입력해주세요(Enter your vaccine serial key)\033[0m\n"


cd /opt/turbovaccine/vaccine/RunScanner
./Update -key




#echo -e "입력한 시리얼키는(The entered serial key is): "
cd /opt/turbovaccine/vaccine/RunScanner
./Update -read


touch /opt/turbovaccine/vaccine/exclExt.txt
touch /opt/turbovaccine/vaccine/exclPath.txt
touch /opt/turbovaccine/vaccine/RunScanner/rtset.txt
touch /opt/turbovaccine/vaccine/RunScanner/rtatc.txt
touch /opt/turbovaccine/vaccine/RunScanner/emergency.txt
touch /opt/turbovaccine/vaccine/RunScanner/Upatc.txt



declare -a TEMP2
	TEMP1=$(uname --kernel-release)
	TEMP2=(${TEMP1//[.-]/ })
	VERSION=$(((${TEMP2[0]} * 10000)\
		+ (${TEMP2[1]} * 100)\
		+ ${TEMP2[2]}))


if [ $VERSION -ge 20636 -a $VERSION -le 20639 ] || [ $VERSION -ge 30000 -a $VERSION -le 31900 ] || [ $VERSION -ge 40000 ];  then 

 EMERGENCY=on
 echo "on" > /opt/turbovaccine/vaccine/RunScanner/emergency.txt
# echo YES ;

else 

	if [ $VERSION -ge 20625 ]; then
  	   EMERGENCY=off
           echo "off" > /opt/turbovaccine/vaccine/RunScanner/emergency.txt
	fi 


#echo NO
fi



if [ "$EMERGENCY" == "off" ]; then



if cat /etc/*release | grep ^NAME | grep Ubuntu || cat /etc/*release | grep ^NAME | grep Debian  || cat /etc/*release | grep ^NAME | grep Mint || cat /etc/*release | grep ^NAME | grep TmaxOS || cat /etc/*release | grep ^NAME | grep gooroom || cat /etc/*release | grep ^NAME | grep Mint ||  cat /etc/*release | grep ^NAME | grep Knoppix ; then
   $UPDATE install wget gcc make curl -y
elif cat /etc/*release | grep ^NAME | grep openSUSE ; then
   $UPDATE install wget gcc make curl 

else
   $UPDATE install wget gcc -y
fi





echo -e "\n\033[1mBuild the RedirFS kernel modules for real-time protection...\033[0m\n"




if ! test -d /lib/modules/`uname -r`/build; then
#    echo -e "\nThen linux kernel source or linux kernel headers for your current kernel version $(uname -r) can not be found."
#    echo -e "Please install the kernel source or kernel headers for $(uname -r), then run this script again."

	$UPDATE  install $kernelheader$(uname -r) -y

	cd /lib/modules/*
	rm -f source build
	ln -s /usr/src/$kernelsrc$(uname -r)  build
	ln -s build source
	#exit 1
fi


if ! test -d /lib/modules/`uname -r`/build; then
    wget http://www.turboupdate.com/TurboLinux/kernel/$kernelheader$(uname -r).rpm
	ls $kernelheader$(uname -r).rpm
	 
	if [ $? -eq 0 ]
	then
	  rpm -ivh $kernelheader$(uname -r).rpm
	else
	  echo "file doesn't exist!!" >&2
	fi
    
    #echo -e "\nThen linux kernel source or linux kernel headers for your current kernel version $(uname -r) can not be found."
    #echo -e "Please install the kernel source or kernel headers for $(uname -r), then run this script again."

	
    #	exit 1
fi

if ! test -d /lib/modules/`uname -r`/build; then

    echo -e "\nThen linux kernel source or linux kernel headers for your current kernel version $(uname -r) can not be found."
    echo -e "Please download the $kernelheader$(uname -r).rpm in web and execute  `rpm -ivh $kernelheader$(uname -r).rpm`, then run this script again."

	
#	exit 1
fi


test -d /tmp/driver && rm -rf /tmp/driver

cd /opt/turbovaccine/lib

tar -zxvf ./driver.tar.gz -C /tmp
cd /tmp/driver
ROOT_PATH=/tmp/driver make all
ROOT_PATH=/tmp/driver make install
/sbin/depmod -a

if /sbin/modprobe redirfs && /sbin/modprobe avflt; then
    echo -e "\nRedirFS kernel modules have been successfully installed.\n"
else
    echo -e "\nRedirFS kernel modules installation failed.\n"
fi

rm -rf /tmp/driver



fi





if [ "$EMERGENCY" == "" ]; then
 echo "Real-time scan is supported only for kernel versions greater than 2.6.25."
 received=$(uname -r)
 echo "The current version is $rereceived"
#  exit 1
fi



echo -e "turbovacine engine update ...\n Wait a fewer minute..."
cd /opt/turbovaccine/vaccine/RunScanner
./Update -updateinit




echo -e "turbovaccine start..."

/etc/init.d/turbovaccine start
#service turbovaccine restart



if [ $VERSION -ge 31000 ];  then 
	if cat /etc/*release | grep ^NAME | grep Ubuntu || cat /etc/*release | grep ^NAME | grep TmaxOS || cat /etc/*release | grep ^NAME | grep gooroom || cat /etc/*release | grep ^NAME | grep Mint || cat /etc/*release | grep ^NAME | grep Debian ; then
	sudo ufw allow 8081/tcp
	else
	firewall-cmd --permanent --zone=public --add-port=8081/tcp
	firewall-cmd --reload >/dev/null 2>&1
	fi

else
iptables -I INPUT -p tcp --dport 8081 -j ACCEPT
iptables -I OUTPUT -p tcp --dport 8081 -j ACCEPT
service iptables save
/etc/init.d/iptables restart

fi

/etc/init.d/crond restart >/dev/null 2>&1 



